aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorKimplul <kimi.h.kuparinen@gmail.com>2025-01-04 00:09:20 +0200
committerKimplul <kimi.h.kuparinen@gmail.com>2025-01-04 00:09:20 +0200
commitb9b5e343accd95b476a8a80e0b713521c7eb6974 (patch)
tree3a0dbc9af281cdea578ad0f92a5ce4b588adff0e
downloadejit-calc-b9b5e343accd95b476a8a80e0b713521c7eb6974.tar.gz
ejit-calc-b9b5e343accd95b476a8a80e0b713521c7eb6974.zip
calculator works on constant string
-rw-r--r--.gitignore3
-rw-r--r--.gitmodules3
-rw-r--r--Makefile46
m---------deps/ejit0
-rwxr-xr-xscripts/gen-deps37
-rw-r--r--scripts/makefile71
-rw-r--r--src/main.c62
-rw-r--r--src/source.mk2
8 files changed, 224 insertions, 0 deletions
diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..5339293
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,3 @@
+build
+calc
+deps.mk
diff --git a/.gitmodules b/.gitmodules
new file mode 100644
index 0000000..d535068
--- /dev/null
+++ b/.gitmodules
@@ -0,0 +1,3 @@
+[submodule "deps/ejit"]
+ path = deps/ejit
+ url = https://metanimi.dy.fi/git/ejit
diff --git a/Makefile b/Makefile
new file mode 100644
index 0000000..1afd6d9
--- /dev/null
+++ b/Makefile
@@ -0,0 +1,46 @@
+.PHONY: all
+all: setup
+ $(MAKE) -f scripts/makefile
+
+# this kicks all unrecognised targets to the client script.
+# note that trying to compile individual files, e.g.
+#
+# make kernel.elf
+#
+# will not work, you would need
+#
+# make -f scripts/makefile kernel.elf
+#
+# instead
+.DEFAULT: setup
+ $(MAKE) -f scripts/makefile $<
+
+.PHONY: analyze
+analyze: setup
+ CC='gcc -fanalyzer' SKIP_ANALYZER='-fno-analyzer' $(MAKE) CROSS_COMPILE=
+
+.PHONY: setup
+setup: deps
+ @echo -n > deps.mk
+ @./scripts/gen-deps -p CALC -c COMPILE_CALC -b calc "$(CALC_SOURCES)"
+
+CLEANUP := build deps.mk calc
+CLEANUP_CMD :=
+CALC_SOURCES :=
+
+include src/source.mk
+
+.PHONY: check
+check: all
+ $(MAKE) -C tests -k check
+
+RM = rm
+
+.PHONY: clean
+clean:
+ $(RM) -rf $(CLEANUP)
+ $(MAKE) -C deps/ejit clean
+
+.PHONY: deps
+deps:
+ $(MAKE) -C deps/ejit
diff --git a/deps/ejit b/deps/ejit
new file mode 160000
+Subproject 28c1822ec742ea0d469a3631115ed68507c1179
diff --git a/scripts/gen-deps b/scripts/gen-deps
new file mode 100755
index 0000000..f45707c
--- /dev/null
+++ b/scripts/gen-deps
@@ -0,0 +1,37 @@
+#!/bin/sh
+
+PREFIX=
+COMPILE=COMPILE
+LINT=LINT
+BUILD=build/
+
+while getopts "p:c:b:l:" opt; do
+ case "$opt" in
+ p) PREFIX="$OPTARG"_;;
+ c) COMPILE="$OPTARG";;
+ l) LINT="$OPTARG";;
+ b) BUILD=build/"$OPTARG";;
+ *) echo "unrecognised option -$OPTARG" >&2; exit 1;;
+ esac
+done
+
+shift $((OPTIND - 1))
+
+# create all subdirectories
+mkdir -p $(echo "${@}" | tr ' ' '\n' | sed "s|[^/]*$||;s|^|${BUILD}/|" | uniq)
+
+for s in ${@}
+do
+ obj="${BUILD}/${s%.*}.o"
+ lint="${obj}.l"
+ dep="${obj}.d"
+
+ echo "${PREFIX}OBJS += ${obj}" >> deps.mk
+ echo "${PREFIX}LINTS += ${lint}" >> deps.mk
+ echo "${dep}:" >> deps.mk
+ echo "-include ${dep}" >> deps.mk
+ echo "${obj}: ${s}" >> deps.mk
+ echo " \$(${COMPILE}) -c ${s} -o ${obj}" >> deps.mk
+ echo "${lint}: ${s}" >> deps.mk
+ echo " \$(${LINT}) -c ${s} -o /dev/null" >> deps.mk
+done
diff --git a/scripts/makefile b/scripts/makefile
new file mode 100644
index 0000000..fc29388
--- /dev/null
+++ b/scripts/makefile
@@ -0,0 +1,71 @@
+# this could be done better
+RELEASE ?= 0
+OPTFLAGS != [ "$(RELEASE)" != "0" ] \
+ && echo "-O2" \
+ || echo "-O0"
+
+LTO ?= 0
+LTOFLAGS != [ "$(LTO)" != "0" ] \
+ && echo "-flto=auto"
+
+DEBUG ?= 1
+DEBUGFLAGS != [ "$(DEBUG)" != "0" ] \
+ && echo "-DDEBUG=1" \
+ || echo "-DNDEBUG=1"
+
+ASSERT ?= 1
+ASSERTFLAGS != [ "$(ASSERT)" != "0" ] \
+ && echo "-DASSERT=1" \
+ || echo
+
+DEPFLAGS = -MT $@ -MMD -MP -MF $@.d
+LINTFLAGS := -fsyntax-only
+PREPROCESS := -E
+
+LLVM ?= 0
+BUILD := build
+
+all: calc
+
+# default values, overwrite if/when needed
+CROSS_COMPILE :=
+
+OBJCOPY != [ "$(LLVM)" != "0" ] \
+ && echo llvm-objcopy \
+ || echo $(CROSS_COMPILE)objcopy
+
+COMPILER != [ -n "$(CROSS_COMPILE)" ] \
+ && { \
+ [ "$(LLVM)" != "0" ] \
+ && echo clang --target="$(CROSS_COMPILE)" \
+ || echo $(CROSS_COMPILE)gcc \
+ ; \
+ } \
+ || echo $(CC)
+
+
+OBFLAGS := -g
+WARNFLAGS := -Wall -Wextra
+
+COMPILE_FLAGS := $(CFLAGS) $(WARNFLAGS) $(OPTFLAGS) $(LTOFLAGS) \
+ $(OBFLAGS) $(ASSERTFLAGS) $(DEBUGFLAGS)
+
+INCLUDE_FLAGS := -I include
+
+COMPILE = $(COMPILER) \
+ $(COMPILE_FLAGS) $(DEPFLAGS) $(INCLUDE_FLAGS)
+
+LINT = $(COMPILER) \
+ $(COMPILE_FLAGS) $(LINTFLAGS) $(INCLUDE_FLAGS)
+
+COMPILE_CALC = $(COMPILE) $(CALC_FLAGS)
+
+-include deps.mk
+
+calc: $(CALC_OBJS) deps/ejit/ejit.o
+ $(COMPILE_CALC) $(CALC_OBJS) deps/ejit/ejit.o -o $@
+
+
+# might lint some common things twice
+.PHONY:
+lint: $(EK_LINTS)
diff --git a/src/main.c b/src/main.c
new file mode 100644
index 0000000..27fe68e
--- /dev/null
+++ b/src/main.c
@@ -0,0 +1,62 @@
+#include <stdio.h>
+#include <inttypes.h>
+
+#include "../deps/ejit/include/ejit/ejit.h"
+
+static struct ejit_func *compile(const char *program)
+{
+ struct ejit_func *func = ejit_create_func(EJIT_INT32, 0, NULL);
+ if (!func) {
+ fprintf(stderr, "failed allocating func\n");
+ return NULL;
+ }
+
+ /* initialize accumulator */
+ ejit_movi(func, EJIT_GPR(0), 0);
+
+ /* load constant 2 into register for multiplication/division since ejit
+ * doesn't have muli/divi instructions */
+ ejit_movi(func, EJIT_GPR(1), 2);
+
+ char c = 0;
+ while ((c = *program++))
+ switch (c) {
+ case '+': ejit_addi(func, EJIT_GPR(0), EJIT_GPR(0), 1); break;
+ case '-': ejit_subi(func, EJIT_GPR(0), EJIT_GPR(0), 1); break;
+ case '*': ejit_mulr(func, EJIT_GPR(0), EJIT_GPR(0), EJIT_GPR(1)); break;
+ case '/': ejit_divr(func, EJIT_GPR(0), EJIT_GPR(0), EJIT_GPR(1)); break;
+ default: break;
+ }
+
+ /* return accumulator */
+ ejit_retr(func, EJIT_GPR(0));
+
+ /* we use GPRs 0 and 1, so 2 in total, no FPRs, and we don't use 64 bit
+ * values (explicitly at least) */
+ ejit_compile_func(func, 2, 0, false);
+ return func;
+}
+
+static int32_t run(struct ejit_func *func)
+{
+ return ejit_run_func(func, 0, NULL);
+}
+
+static void destroy(struct ejit_func *func)
+{
+ ejit_destroy_func(func);
+}
+
+int main()
+{
+ const char *program = "+ + * - /";
+ struct ejit_func *func = compile(program);
+ if (!func) {
+ fprintf(stderr, "failed to compile program\n");
+ return -1;
+ }
+
+ int32_t result = run(func);
+ printf("%" PRIi32 "\n", result);
+ destroy(func);
+}
diff --git a/src/source.mk b/src/source.mk
new file mode 100644
index 0000000..5b2c0e3
--- /dev/null
+++ b/src/source.mk
@@ -0,0 +1,2 @@
+SRCS != echo src/*.c
+CALC_SOURCES += $(SRCS)